part of masamune;

class PlatformAppLayout extends HookWidget {
  const PlatformAppLayout({required this.builder, required this.initialPath});

  final String initialPath;
  final Widget Function(
          BuildContext context, bool isMobile, NavigatorController? controller)
      builder;
  @override
  Widget build(BuildContext context) {
    final isMobile = Config.isMobile;
    if (isMobile) {
      return builder.call(context, isMobile, null);
    } else {
      final controller = useNavigatorController(initialPath);

      return CMSLayout(
        sideBorder: const BorderSide(),
        leftBar: builder.call(context, isMobile, controller),
        child: InlinePageBuilder(controller: controller),
      );
    }
  }
}
